import astropy,os,scipy.interpolate,sys,scipy.signal
import numpy as np
from astropy.io import fits

#os.system('ls d????.*.fits > fits.lst')

for line in open("fits.lst"):
    line=line.strip("\n")

    object=fits.open(line)
    xx=int(object[1].header['NAXIS1'])
    yy=int(object[1].header['NAXIS2'])
    print(line,fits.getval(line,'IMAGETYP',0),xx,yy)

    x1=np.linspace(0,2047,2048)
    y1=np.linspace(0,0,2048)
    x2=np.linspace(0,2015,2016)
    y2=np.linspace(0,0,2016)

    for k in range(16):
        data=object[k+1].data
#        print(object[k+1].data[2058,480])
        data1=np.empty((yy,2036),dtype=np.float32)
        if(yy==2048):
            for i in range(yy):
                xmedian=np.median(data[i,xx-20:xx])
                y1[i]=xmedian

            c=scipy.interpolate.UnivariateSpline(x1,y1)
            c.set_smoothing_factor(8000)

            for i in range(yy):
                data1[i,:xx-20]=np.float32(data[i,:xx-20])-c(i)
#            print(data1[100,100],c(100),data[100,100])
        else:
            overscan=np.zeros((yy-20,xx-20))

            for i in range(yy-20):
                xmedian=np.median(data[i,xx-20:xx])
                y1[i]=xmedian

            c=scipy.interpolate.UnivariateSpline(x1,y1)
            c.set_smoothing_factor(8000)

            for i in range(xx-20):
                ymedian=np.median(data[2048:2068,i])
                if(abs(ymedian-np.median(data[2048:2068,max(0,i-50):min(2016,i+50)])) >= 10.):
                    y2[i]=np.median(data[2048:2068,max(0,i-50):min(2016,i+50)])
#                    y2[i]=np.median(data[2048:2068,:])
                else:
                    y2[i]=ymedian

                if(y2[i] >= 30000.):
                    y2[i]=np.median(data[2048:2068,:])

#                ymedian=np.median(data[yy-20:yy,i])
#                y2[i]=ymedian

            d=scipy.interpolate.UnivariateSpline(x2,y2)
            d.set_smoothing_factor(8000)

#            print(k,overscan[1000,1000])
            for i in range(yy-20):
                overscan[i,:xx-20]=overscan[i,:xx-20]+c(i)
#            print(overscan[1000,1000])

            for j in range(xx-20):
                overscan[:yy-20,j]=overscan[:yy-20,j]+d(j)
#            print(overscan[1000,1000])

            overscan=overscan/2
#            print(overscan[1000,1000])

            data1=np.float32(data)
            data1[:yy-20,:xx-20]=np.float32(data[:yy-20,:xx-20])-overscan[:yy-20,:xx-20]

        object[k+1].data=data1
#        print(object[k+1].data[2058,2026])
#        del object[k+1].header['BSCALE']
#        del object[k+1].header['BZERO']

#            print(k,data[2030,2030],data1[2030,2030])

    line1=line.replace('d','e')

    object.writeto(line1[:15],clobber='Ture')
    object.close()
